/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.MotivoCancelVendaPacoteDAO;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelVendaPacote;

/**
 *
 * @author Bruno
 */
@Repository("motivoCancelacionVendaPacoteDAO")
public class MotivoCancelVendaPacotelHibernateDAO extends GenericHibernateDAO<MotivoCancelVendaPacote, Integer>
        implements MotivoCancelVendaPacoteDAO {

    @Autowired
    public MotivoCancelVendaPacotelHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<MotivoCancelVendaPacote> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descmotivocancel"));

        return c.list();
    }

    public List<MotivoCancelVendaPacote> buscar(String descmotivocancel, String tipomotivocancel) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("descmotivocancel", descmotivocancel));
        c.add(Restrictions.eq("tipomotivocancel", tipomotivocancel));

        return c.list();
    }

    public List<MotivoCancelVendaPacote> obtenerTodosTipoMotivoCancel() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descmotivocancel"));

        return c.list();
    }

    public List<MotivoCancelVendaPacote> obtenerTodosEspecificos(Integer[] motivos) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.in("motivocancelacionId", motivos));
        c.addOrder(Order.asc("descmotivocancel"));

        return c.list();
    }
}
